//
//  SceneDelegate.swift
//  OrderScheduling
//
//  Created by 中道 on 2023/8/3.
//

import UIKit

class SceneDelegate: UIResponder, UIWindowSceneDelegate {

    public var window: UIWindow?
    public var initial : Initial = Initial.shareInstance
    public var appIsAlive : Bool = false
    
    func scene(_ scene: UIScene, willConnectTo session: UISceneSession, options connectionOptions: UIScene.ConnectionOptions) {
        // Use this method to optionally configure and attach the UIWindow `window` to the provided UIWindowScene `scene`.
        // If using a storyboard, the `window` property will automatically be initialized and attached to the scene.
        // This delegate does not imply the connecting scene or session are new (see `application:configurationForConnectingSceneSession` instead).
        guard let windowSence = (scene as? UIWindowScene) else { return }
        // 初始化第三方的lib
        initial.initThirdLib()
        
        window = UIWindow(windowScene: windowSence)
        window?.makeKeyAndVisible()
        initial.changeRootViewController(window: window)
        initial.initRootViewController()
    }

    func sceneDidDisconnect(_ scene: UIScene) {
        // Called as the scene is being released by the system.
        // This occurs shortly after the scene enters the background, or when its session is discarded.
        // Release any resources associated with this scene that can be re-created the next time the scene connects.
        // The scene may re-connect later, as its session was not necessarily discarded (see `application:didDiscardSceneSessions` instead).
    }

    func sceneDidBecomeActive(_ scene: UIScene) {
        // 处理app收到推送后写入GROUP的数据，当app处于后台时才要弹出，app热启动时不需要
        TOOL.dealWithOrderPushNotification {[weak self] userInfo in
            if USER.isLogin == true,self?.appIsAlive == true {
                TOOL.playAlertWith(userInfo: userInfo)
            }
        }
        
        // 登录时需要处理培训问题
        if USER.isLogin == true, appIsAlive == true {
            NewTraining.default.newTrainingRelay.accept(nil)
        }
        
        // 在服务商登录调度app后，弹框提醒服务商
        if USER.isLogin == true, appIsAlive == true {
            UserData.default.showGongdanpiciAlert()
        }
        
        // 说明app时活的，用来判断进入后台之后返回前台时的问题
        appIsAlive = true
    }

    func sceneWillResignActive(_ scene: UIScene) {
        // Called when the scene will move from an active state to an inactive state.
        // This may occur due to temporary interruptions (ex. an incoming phone call).
    }

    func sceneWillEnterForeground(_ scene: UIScene) {
        // Called as the scene transitions from the background to the foreground.
        // Use this method to undo the changes made on entering the background.
        // 后台收到通知后或者不点击通知打开app，激活时消除badge
        JPUSHService.resetBadge()
        UIApplication.shared.applicationIconBadgeNumber = 0
        
        if USER.isLogin == true {
            // app激活就要获取最新消息个数，要在refreshToken之后
            MCOUNT.newestMessage()
        }
    }
    
    func scene(_ scene: UIScene, openURLContexts URLContexts: Set<UIOpenURLContext>) {
        guard let url = URLContexts.first?.url else { return }
        handlePayCallbackURL(url)
    }

    func sceneDidEnterBackground(_ scene: UIScene) {
        // Called as the scene transitions from the foreground to the background.
        // Use this method to save data, release shared resources, and store enough scene-specific state information
        // to restore the scene back to its current state.
    }


}

